// Rouslan Synth 2011-2015
#include <stdio.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include "declarations.h"

float semitone2Hz(float semitone)
{
    return 440.0f * pow(2.0f, (semitone - 69.0f)/12.0f);
}

int main(int argc, char *argv[])
{
	int n;

	FILE *f = fopen("tables.h", "w");

	fprintf(f, "const u16 note2offset[] = { // SAMPLE_RATE = %d\n\t", SAMPLE_RATE);
	
	for(n=MIDI_NOTE_OFFSET; n<=MIDI_HIGHEST_NOTE; n++) {
		int offset = (int)(1024.0*WAVET_SIZE*semitone2Hz(n)/SAMPLE_RATE + 0.5f); // scale by 1024 to increase resolution while still fitting in u16

		fprintf(f, "%d,", offset);
	}
	
	fprintf(f, "\n};\n\nconst s8 sine[] = {\n\t");
	
	for(n=0; n<WAVET_SIZE; n++) {
		fprintf(f, "%d,", (int)(127.0f * sinf((float)M_PI*n / WAVET_SIZE))); // Store half period of sinusoid
	}
/*
	fprintf(f, "\n};\n\nconst s8 note2filter[] = {\n\t");
	
	for(n=MIDI_NOTE_OFFSET; n<=MIDI_HIGHEST_NOTE; n++) {
		float Hz = semitone2Hz(n);
		float C = 2.0f*M_PI*Hz/SAMPLE_RATE;
		fprintf(f, "%d,", (int)(256.0f*C/(C+1))); // http://en.wikipedia.org/wiki/Low-pass_filter#Simple_infinite_impulse_response_filter
	}
*/
	fprintf(f, "\n};\n");

	fclose(f);
}
